#ifndef MUI_USERDATA_MCC_H
#define MUI_USERDATA_MCC_H

/*
** Custom class header files should have a "_mcc" appended and
** should be place in include:MUI/
*/

/*
** Public name for the custom class.
** Note that you *must* register public names with the author of MUI.
** All unregistered public classes are promised to go on a builtin
** blacklist and will fail with future versions of MUI!
*/

#define MUIC_UserData "UserData.mcc"

/*
** Attributes and methods for the new class.
** Your tags have to be named MUI(A/M)_<classname>_<foobar>.
** The upper sixteen bits of your tag values need to be
** (TAG_USER | ( <your MUI serial Nr> << 16 ))
** Again, classes with invalid tag specs are promised to
** go on the blacklist. This implies that you have to
** be a registered MUI user if you want to distribute
** public classes.
*/

#define MUIA_UserData_Name    ((TAG_USER | ( 1 << 16)) | 0x0001)
#define MUIA_UserData_First   ((TAG_USER | ( 1 << 16)) | 0x0002)
#define MUIA_UserData_Street  ((TAG_USER | ( 1 << 16)) | 0x0003)
#define MUIA_UserData_City    ((TAG_USER | ( 1 << 16)) | 0x0004)
#define MUIA_UserData_Country ((TAG_USER | ( 1 << 16)) | 0x0005)
#define MUIA_UserData_EMail   ((TAG_USER | ( 1 << 16)) | 0x0006)
#define MUIA_UserData_Phone   ((TAG_USER | ( 1 << 16)) | 0x0007)

#define MUIM_UserData_Edit    ((TAG_USER | ( 1 << 16)) | 0x0101)
#define MUIM_UserData_Print   ((TAG_USER | ( 1 << 16)) | 0x0102)

#define UserDataObject MUI_NewObject(MUIC_UserData

#endif
